function Blatt3 
clear all; close all; clc;

dbstop if error  % sobald ein Fehler im code ist, erhält man an der Stelle Zugriff auf den workspace (siehe "keyboard")

% Werte aus der Aufgabe
T=50;
h=0.1;
y0=[4,0];
r1=[0,-1];
f1=[1,0];
r2=[0,-2/5];
f2=[4/5,1/5];
% berechne Lösung
[y1,y2]=Liebesdynamik(T,h,y0,r1,f1,2);
[y3,y4]=Liebesdynamik(T,h,y0,r2,f2,1);
yex1=@(t)[4*cos(t),-4*sin(t)];
yex2=@(t)exp(t/5).*[4*cos(sqrt(3)*t/5)-4*sqrt(3)*sin(sqrt(3)*t/5)/3,...
   -4*sqrt(3)*sin(sqrt(3)*t/5)/3];

% time interval (for plots)
t = 0:h:T;
 
figure(1)
plot(t(:), y1,'g-',t(:),y2,'k',t(:),yex1(t(:)),'--')
legend('Romeo','Julia','Location','Best'); % Legende im plot
title('Julia (y2) und Romeo (y1) ueber t')
xlabel('Zeit t')
ylabel('y1,y2')


figure(2)
plot(t(:), y3,'g-',t(:),y4,'k')
legend('Romeo','Julia','Location','Best'); % Legende im plot
title('Julia (y2) und Romeo (y1) ueber t')
xlabel('Zeit t')
ylabel('y1,y2')

h=0.0001:0.0001:0.1;
explizit=[];
implizit=[];
for i=1:length(h)
    [y1,y2]=Liebesdynamik(T,h(i),y0,r1,f1,1);
    [y3,y4]=Liebesdynamik(T,h(i),y0,r1,f1,2);
    yex=[y1,y2];
    yim=[y3,y4];
    th=h(i)*(0:floor(T/h(i)));
    explizit=[explizit,norm(yex-yex1(th(:)))];
    implizit=[implizit,norm(yim-yex1(th(:)))];
end
asdf=7;
figure(3)
plot(h, explizit,'g-',h, implizit,'b')
legend('Explizit','Location','Best'); % Legende im plot
title('Fehler bei variirender Schrittweite')
xlabel('Schrittweite h')
ylabel('Fehler')



function [y1,y2] = Liebesdynamik(T,h,y0,r,f,modus)
%
%T... Endzeitpunkt
%h... Zeitschrittweite
%y0... Startwerte der Liebesdynamik
%r,f... Parameter
%y1,y2... Aktueller Stand der Liebe (y1 -> Romeo, y2 -> Julia)

% Initialisierung:
N =  floor(T/h); 
y1 = zeros(N+1,1); % Es gibt N+1 Punkte
y2 = zeros(N+1,1);
% Anfangswerte
y1(1) = y0(1);
y2(1) = y0(2);


if modus == 1
    %Explizites Euler-Verfahren 
    for j=1:N
        y1(j+1)=y1(j)+h*(r(1)*y1(j)+f(1)*y2(j));
        y2(j+1)=y2(j)+h*(r(2)*y1(j)+f(2)*y2(j));    
    end
    %Implizites Euler-Verfahren 
elseif modus == 2
    M=[1-h*r(1),-h*f(1);-h*r(2),1-h*f(2)];
    for j=1:N
        y=M\[y1(j);y2(j)];
        y1(j+1)=y(1);
        y2(j+1)=y(2);
    end
end

